/*
 * NixieZ566M.c
 *
 * Created: 2014-04-02 13:54:06
 *  Author: Trojan
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>	// include interrupt support
#include <util/delay.h>
#include "i2clib.h"
#include "NixieZ566Mfunclib.h"





volatile uint16_t i,j;

uint8_t liczby[11] = {2,6,14,10,12,4,0,1,5,8,11};
volatile uint8_t lampy[4] = {1,2,3,4};

volatile uint8_t dim_string[6] = {17,1,18,19,11,11};

volatile uint8_t time[6];
volatile uint8_t current_lamp = 1;
volatile uint8_t dim_level;
volatile uint8_t dim;
volatile uint8_t light_level;

enum status
{
	NORMAL, SET, DIMCHECK, DIMSET
} mode;



int main(void)
{
TWBR = 0;

get_time();
mode = NORMAL;

ADMUX = 0b01100110;
ADCSRA = 0b10000111;
	
DDRB = 0b00110001;
DDRD = 0b10011110;
PORTB = 0b00110001;
PORTD = 0b10000000;
PORTD += 12;
TCCR0 = 0b10;
TIMSK |= 1;

get_dimlevel();

WDTCR |= (1<<WDCE) | (1<<WDE);
WDTCR = 0b1111;
sei();


while(1)
{

while(mode == NORMAL)
{
	if(bit_is_clear(PINB, 3))
	{
		cli();
		lamps_down();
		_delay_ms(400);
		sei();
		mode = SET;
	}
	if (j > 3000)
	{
		j=0;
		ReadADC(6);
		if(dim_level > 2 && dim_level < 253)
		{
		if(light_level < dim_level) dim = 1;
		if(light_level > dim_level) dim = 0;
		}
	
		
	}
}

while(mode == SET)
	{
	if (bit_is_clear(PINB, 2))
	{
		_delay_ms(150);
		adj_time(1);
		get_time();
		_delay_ms(150);
		j = 0;
		while (j < 120)
		{
			if (bit_is_set(PINB, 2)) break;
		}
	while (bit_is_clear(PINB, 2)) {  adj_time(1); get_time();  _delay_ms(20);}
	}
		
	if (bit_is_clear(PINB, 1))
	{
		_delay_ms(150);
		adj_time(0);
		get_time();	
		_delay_ms(150);
		j = 0;
		while (j < 120)
		{
			if (bit_is_set(PINB, 1)) break;
		}
		while (bit_is_clear(PINB, 1)) {  adj_time(0); get_time();  _delay_ms(20);}
		}
			
				if(bit_is_clear(PINB, 3))
				{
					cli();
					lamps_down();
					_delay_ms(400);
					sei();
					mode = DIMCHECK;
				}
	}
	
while(mode == DIMCHECK)
	{
	get_adc();
	_delay_ms(50);
	if(bit_is_clear(PINB, 3))
		{
				cli();
				lamps_down();
				_delay_ms(400);
				sei();
			mode = DIMSET;
			get_dimlevel();
			show_dimlevel();
		}
	}
	
while(mode == DIMSET)
	{
		if (bit_is_clear(PINB, 2))
		{
			_delay_ms(150);
			dim_level++;
			set_dimlevel();
			show_dimlevel();
			_delay_ms(150);
			j = 0;
			while (j < 120)
			{
				if (bit_is_set(PINB, 2)) break;
			}
			while (bit_is_clear(PINB, 2)) { dim_level++;  show_dimlevel(); _delay_ms(20);}
		}
		
		if (bit_is_clear(PINB, 1))
		{
			_delay_ms(150);
			dim_level--;
			set_dimlevel();
			show_dimlevel();
			_delay_ms(150);
			j = 0;
			while (j < 120)
			{
				if (bit_is_set(PINB, 1)) break;
			}
			while (bit_is_clear(PINB, 1)) { dim_level--;  show_dimlevel(); _delay_ms(20);}
		}
		if(bit_is_clear(PINB, 3))
		{
			set_dimlevel();
			cli();
			lamps_down();
			_delay_ms(400);
			mode = NORMAL;
			sei();
			get_time();
		}
	}

}




} // main - end

ISR(TIMER0_OVF_vect)
{
	asm("wdr");
	PORTB &= 0b11001110;
	PORTD &= 0b01100001;

	i++;
	j++;
	
	if ((i%2)&&dim) return;
	if (!(i%10000)) get_time();
	if (current_lamp == 0) { PORTD |= liczby[lampy[0]]*2; PORTD |= 0b10000000; current_lamp++; return;}
	if (current_lamp == 1) { PORTD |= liczby[lampy[1]]*2; PORTB |= 0b1; current_lamp++; return;}
	if (current_lamp == 2) { PORTD |= liczby[lampy[2]]*2; PORTB |= 0b00010000;  current_lamp++; return;}
	if (current_lamp == 3) { PORTD |= liczby[lampy[3]]*2; PORTB |= 0b00100000; current_lamp=0; return;}
}

