/*
 * NixieZ566Mfunclib.c
 *
 * Created: 2014-04-09 09:17:13
 *  Author: Trojan
 */ 

#include "NixieZ566Mfunclib.h"
#include "i2clib.h"


void get_time()
{
	
	uint8_t hours;
	uint8_t minutes;
	
	cli();
	i2c_start();
	i2c_write(DS1307W);
	i2c_write(0x00);
	i2c_stop();
	
	i2c_start();
	i2c_write(DS1307R);
	i2c_read(1);
	minutes = i2c_read(1);
	hours = i2c_read(0);
	i2c_stop();
	sei();
	
	lampy[1] = hours & 0x0F;
	lampy[0] = hours>>4;
	
	lampy[3] = minutes & 0x0F;
	lampy[2] = minutes>>4;
	
}

void get_dimlevel()
{
	cli();
	
	i2c_start();
	i2c_write(DS1307W);
	i2c_write(DIM_ADDR);
	i2c_stop();
	
	i2c_start();
	i2c_write(DS1307R);
	dim_level = i2c_read(0);
	i2c_stop();
	sei();
}

void show_dimlevel()
{
	uint8_t adc8 = dim_level;
	lampy[0] = 0;
	lampy[1] = adc8 / 100;
	adc8 = adc8 - lampy[1] * 100;
	lampy[2] = adc8 /10;
	lampy[3] = adc8 % 10;
}

void set_dimlevel()
{
	cli();
	i2c_start();
	i2c_write(DS1307W);
	i2c_write(DIM_ADDR);
	i2c_write(dim_level);
	i2c_stop();
	sei();
}

void adj_time(uint8_t direction)
{
	cli();

	uint8_t hours;
	uint8_t minutes;
	
	get_time();
	
	if(direction)
	{
	lampy[3]++;
	if(lampy[3] > 9)
	{
		lampy[3] = 0;
		lampy[2]++;
		if( lampy[2] > 5)
		{
			lampy[2] = 0;
			lampy[1]++;
			if (lampy[1] > 9 || (lampy[0] == 2 && lampy[1] > 3))
			{
				lampy[1] = 0;
				lampy[0]++;
				if (lampy[0] > 2) lampy[0] = 0;
			}
			
		}
	}
	}
	else
	{

	lampy[3]--;
	if(lampy[3] > 200)
	{
		lampy[3] = 9;
		lampy[2]--;
		if( lampy[2] > 200)
		{
			lampy[2] = 5;
			lampy[1]--;
			if (lampy[1] > 200)
			{
				lampy[1] = 9;
				lampy[0]--;
				if (lampy[0] > 200) {lampy[0] = 2; lampy[1] = 3;}
			}
			
		}
	}
	}
	
	hours = lampy[0]*16 + lampy[1];
	minutes = lampy[2]*16 + lampy[3];
	
	i2c_start();
	i2c_write(DS1307W);
	i2c_write(0x00);
	i2c_write(0x00);
	i2c_write(minutes);
	i2c_write(hours);
	i2c_stop();
	get_time();
	sei();
}


void ReadADC(uint8_t channel)

{
	uint16_t adc = 0;
	uint8_t adc8;
	
	ADMUX = (ADMUX & 0xf0) | channel; // Channel selection
	
	for(int i = 0; i < 16; i++)
	{
		ADCSRA |= _BV(ADSC);                // Start conversion
		while(!bit_is_set(ADCSRA,ADIF)) ;    // Loop until conversion is complete
		ADCSRA |= _BV(ADIF);                // Clear ADIF by writing a 1 (this sets the value to 0)
		adc = adc + ADCH;
	}
	
	adc8 = adc / 16;
	light_level = adc8;
}

void get_adc()
{
	ReadADC(6);
	uint8_t adc8 = light_level;
	lampy[0] = 0;
	lampy[1] = adc8 / 100;
	adc8 = adc8 - lampy[1] * 100;
	lampy[2] = adc8 /10;
	lampy[3] = adc8 % 10;
}

void lamps_down()
{
		PORTB &= 0b11001110;
		PORTD &= 0b01100001;
}